// ---------------------------------------------------------------------------
// Entete du module contenant les services generiques du programme
// ---------------------------------------------------------------------------
// (C) 2010 Morin Pascal
// ---------------------------------------------------------------------------
// V1.0	Cration le 13/09/2010
// ---------------------------------------------------------------------------
#ifndef _SERVICES_
#define _SERVICES_
// ---------------------------------------------------------------------------
//#include "DSP2833x_Device.h"

//------------------------------------------------------------------------------------
// Dfinition du type BOOL
//------------------------------------------------------------------------------------
typedef enum
	{
	FALSE = (int)0,
	TRUE  = (int)1
	} BOOL;

//------------------------------------------------------------------------------------
// Macros permettant de manipuler MSB et LSB pour des mots de 16 et 32 bits
//------------------------------------------------------------------------------------
// BYTE low or high of a 16 bits WORD
#define HI_BYTE(a) ((a & 0xFF00)>>8)
#define LO_BYTE(a)  (a & 0x00FF)

// BYTE low or high WORD of a 32 bits DWORD
#define HI_WORD(a) ((a & 0xFFFF0000)>>16)
#define LO_WORD(a)  (a & 0x0000FFFF)

//------------------------------------------------------------------------------------
// Manipulation du bit (bit) de l'Uint16 ou de l'Uint32 (arg)
//------------------------------------------------------------------------------------
#define BitMsk(bit) (0x00000001 << (bit))				// masque pour bit n - ex: mask(2)=0x0004
#define BitNset(bit,arg) ((arg) |=  BitMsk(bit))		// set bit
#define BitNclr(bit,arg) ((arg) &= ~BitMsk(bit))		// clr bit
#define BitNflp(bit,arg) ((arg) ^=  BitMsk(bit))		// chg bit
#define BIT(bit,arg) ((arg & BitMsk(bit)) >> bit);		// bit "bit" de "arg" = 1 | 0

//------------------------------------------------------------------------------------
// Macros pour faciliter l'ajout d'un certain nombre de NOP
//------------------------------------------------------------------------------------
#define NOP1 \
    asm("    NOP");

#define NOP4 \
    asm("    NOP");\
    asm("    NOP");\
    asm("    NOP");\
    asm("    NOP");

#define NOP8 \
	NOP4 \
	NOP4

#define NOP16 \
	NOP8 \
	NOP8

//------------------------------------------------------------------------------------
// Fonctions uselles (min, max, sign)
//------------------------------------------------------------------------------------
#define min(a,b) ((a<b)?(a):(b))
#define max(a,b) ((a>b)?(a):(b))
#define sign(x)  ((x>=0.0f)?(1.0f):(-1.0f))

//------------------------------------------------------------------------------------
// Constantes gnrales
//------------------------------------------------------------------------------------
#define PI_RAD     	3.1415926535897932384626433832795f
#define PI     		PI_RAD
#define TWO_PI_RAD 	6.283185307179586476925286766559f

// ---------------------------------------------------------------------------
// Macros permettant de dclarer une section critique du code (int desactives)
// ---------------------------------------------------------------------------
// todo
//#define DEBUT_SECTION_CRITIQUE
//#define FIN_SECTION_CRITIQUE


// ---------------------------------------------------------------------------
#endif
// ---------------------------------------------------------------------------
