// -----------------------------------------------------------------------------------------
// Module de gestion de interruptions timer
// -----------------------------------------------------------------------------------------
#include "derivative.h"
#include "gestion_timer.h"
#include "gestion_inputs.h"
#include "gestion_outputs.h"

// -----------------------------------------------------------------------------------------
volatile unsigned int wait_count=0;


// -----------------------------------------------------------------------------------------
// Timer 0 : INT1.7 (interrpution priodique programme  1ms)
// Timer utilis pour crer la base de temps de l'automate 'temps rel'
// -----------------------------------------------------------------------------------------
interrupt void  GESTION_INT_TIMER0(void)      // CPU-Timer 0
{
static TEtatAutomate EtatRT=ETAT_INIT;

// Acquittement de l'interruption
PieCtrlRegs.PIEACK.all = PIEACK_GROUP1;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// Gestion des temporisations
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (wait_count)
	{
	wait_count--;
	}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// Gestion de l'automate RT
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// ( completer en fonction de l'application,
// squence de 10 tats pour cette version)
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
switch(EtatRT)
	{
	case	ETAT_INIT:	// Init  completer en fonction de l'application
						// -----
						// Tbd
						// -----
						// passe  l'tat suivant
						EtatRT=ETAT_GESTION_INPUTS;
						break;

	case	ETAT_GESTION_INPUTS: // tat de dpart de la squence fonctionnelle
						gestion_inputs();

						// passe  l'tat suivant
						EtatRT=ETAT_GESTION_OUTPUTS;
						break;

	case	ETAT_GESTION_OUTPUTS:
						gestion_outputs();

						// passe  l'tat suivant
						EtatRT=ETAT_DUMMY3;
						break;

	case	ETAT_DUMMY3:
	case	ETAT_DUMMY4:
	case	ETAT_DUMMY5:
	case	ETAT_DUMMY6:
	case	ETAT_DUMMY7:
	case	ETAT_DUMMY8:
	case	ETAT_DUMMY9:
						// passe  l'tat suivant
						EtatRT++;
						break;

	case	ETAT_DUMMY10:
						// Retour  l'tat de dpart d'une nouvelle sequence fonctionnelle
						EtatRT=ETAT_GESTION_INPUTS;
						break;

	default:			// Ici en cas d'erreur sur l'tat de l'automate
						EtatRT=ETAT_INIT;
						break;

	}
}

// -----------------------------------------------------------------------------------------
// Fonction d'attente (en ms)
// -----------------------------------------------------------------------------------------
void wait(unsigned int n)
{
wait_count=n;		// transfert atomique (pas besoin de proteger l'accs contre les interruptions)
while(wait_count);	// attend la fin du dcompte sous interruption
}
